/* Generated automatically by the program `genoutput'
   from the machine description file `md'.  */

#define IN_TARGET_CODE 1
#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "tree.h"
#include "rtl.h"
#include "flags.h"
#include "alias.h"
#include "varasm.h"
#include "stor-layout.h"
#include "calls.h"
#include "insn-config.h"
#include "expmed.h"
#include "dojump.h"
#include "explow.h"
#include "memmodel.h"
#include "emit-rtl.h"
#include "stmt.h"
#include "expr.h"
#include "insn-codes.h"
#include "tm_p.h"
#include "regs.h"
#include "conditions.h"
#include "insn-attr.h"

#include "recog.h"

#include "diagnostic-core.h"
#include "output.h"
#include "target.h"
#include "tm-constrs.h"

static const char * const output_1[] = {
  "mov %0,%1",
  "mov %0,%1",
  "mov %0,%1",
  "ldrb %0,%1",
  "strb %1,%0",
};

static const char * const output_2[] = {
  "mov %0,%1",
  "mov %0,%%low(%1); %1",
  "ldrh %0,%c1",
  "strh %1,%c0",
};

static const char *
output_6 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 216 "../../gcc/config/epiphany/epiphany.md"
{
  switch (which_alternative)
    {
    case 0: return "mov %0,%1";
    case 1: return "add %0,%-,(1+%1)";
    case 2: operands[1] = GEN_INT (exact_log2 (-INTVAL (operands[1])));
      return "lsl %0,%-,%1";
    case 3: operands[1] = GEN_INT (32 - exact_log2 (INTVAL (operands[1]) + 1));
      return "lsr %0,%-,%1";
    case 4: return "mov %0,%%low(%1)\n\tmovt %0,%%high(%1) ; %1";
    case 5: return "ldr %0,%C1";
    case 6: return "str %1,%C0";
    case 7: return "movfs %0,%1";
    case 8: return "movts %0,%1";
    default: gcc_unreachable ();
    }
}
}

static const char * const output_8[] = {
  "#",
  "#",
  "ldrd %0,%X1",
  "strd %1,%X0",
};

static const char * const output_9[] = {
  "#",
  "#",
  "ldrd %0,%X1",
  "strd %1,%X0",
};

static const char * const output_10[] = {
  "#",
  "#",
  "ldrd %0,%X1",
  "strd %1,%X0",
};

static const char * const output_11[] = {
  "#",
  "#",
  "ldrd %0,%X1",
  "strd %1,%X0",
};

static const char * const output_12[] = {
  "#",
  "#",
  "ldrd %0,%X1",
  "strd %1,%X0",
};

static const char * const output_13[] = {
  "#",
  "#",
  "ldrd %0,%X1",
  "strd %1,%X0",
};

static const char * const output_14[] = {
  "mov %0,%1",
  "mov %0,%%low(%1)\n\tmovt %0,%%high(%1) ; %1",
  "ldr %0,%C1",
  "str %1,%C0",
};

static const char * const output_15[] = {
  "add %0,%1,%2",
  "sub %0,%1,#%n2",
};

static const char *
output_16 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 460 "../../gcc/config/epiphany/epiphany.md"
{
  int scratch = (0x17
		 ^ (true_regnum (operands[0]) & 1)
		 ^ (true_regnum (operands[1]) & 2)
		 ^ (true_regnum (operands[2]) & 4));
  asm_fprintf (asm_out_file, "\tstr r%d,[sp,#0]\n", scratch);
  asm_fprintf (asm_out_file, "\tmovfs r%d,status\n", scratch);
  output_asm_insn ("add %0,%1,%2", operands);
  asm_fprintf (asm_out_file, "\tmovts status,r%d\n", scratch);
  asm_fprintf (asm_out_file, "\tldr r%d,[sp,#0]\n", scratch);
  return "";
}
}

static const char * const output_46[] = {
  "movfs %0,status",
  "movfs %3,status\n\teor %3,%3,%1\n\tand %3,%3,%2\n\teor %3,%3,%1\n\tmovts status,%3",
};

static const char *
output_58 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 1627 "../../gcc/config/epiphany/epiphany.md"
{
  rtx xop[3];

  xop[0] = operands[0];
  xop[1] = operands[1];
  xop[2] = GEN_INT (31-INTVAL (operands[2]));
  output_asm_insn ("lsl %0,%1,%2", xop);
  return "";
}
}

static const char * const output_59[] = {
  "#",
  "ldrb %0,%1",
};

static const char * const output_60[] = {
  "movt %0, 0",
  "ldrh %0,%c1",
};

static const char * const output_90[] = {
  "b %0",
  "jr %0",
};

static const char * const output_92[] = {
  "b %1",
  "jr %1",
};

static const char *
output_97 (rtx *operands ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
#line 2401 "../../gcc/config/epiphany/epiphany.md"
{
  return (GET_MODE_SIZE (GET_MODE (operands[0])) <= 4
	  ? "str %1,%0,%C2" : "strd %1,%0,%X2");
}
}



static const struct insn_operand_data operand_data[] = 
{
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    0,
    0
  },
  {
    move_dest_operand,
    "=Rcs,r,r,r,m",
    E_QImode,
    0,
    0,
    1,
    1
  },
  {
    move_src_operand,
    "Rcs,rU16,Cal,m,r",
    E_QImode,
    0,
    0,
    1,
    1
  },
  {
    move_dest_operand,
    "=r,r,r,m",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    move_src_operand,
    "rU16,Cal,m,r",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    gpr_operand,
    "=r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    gpr_operand,
    "+r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    move_src_operand,
    "i",
    E_SImode,
    0,
    0,
    1,
    1
  },
  {
    gpr_operand,
    "=r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    move_src_operand,
    "i",
    E_SImode,
    0,
    0,
    1,
    1
  },
  {
    move_dest_operand,
    "=r,r,r,r,r,r,m,r,Rct",
    E_SImode,
    0,
    0,
    1,
    1
  },
  {
    move_src_operand,
    "rU16Rra,Cm1,Cl1,Cr1,Cal,mSra,rRra,Rct,r",
    E_SImode,
    0,
    0,
    1,
    1
  },
  {
    gpr_operand,
    "=r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    gpr_operand,
    "r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    move_dest_operand,
    "=r,r,r,m",
    E_DImode,
    0,
    0,
    1,
    1
  },
  {
    move_double_src_operand,
    "r,CalE,m,r",
    E_DImode,
    0,
    0,
    1,
    1
  },
  {
    move_dest_operand,
    "=r,r,r,m",
    E_DFmode,
    0,
    0,
    1,
    1
  },
  {
    move_double_src_operand,
    "r,CalE,m,r",
    E_DFmode,
    0,
    0,
    1,
    1
  },
  {
    move_dest_operand,
    "=r,r,r,m",
    E_V2SImode,
    0,
    0,
    1,
    1
  },
  {
    move_double_src_operand,
    "r,CalE,m,r",
    E_V2SImode,
    0,
    0,
    1,
    1
  },
  {
    move_dest_operand,
    "=r,r,r,m",
    E_V2SFmode,
    0,
    0,
    1,
    1
  },
  {
    move_double_src_operand,
    "r,CalE,m,r",
    E_V2SFmode,
    0,
    0,
    1,
    1
  },
  {
    move_dest_operand,
    "=r,r,r,m",
    E_V4HImode,
    0,
    0,
    1,
    1
  },
  {
    move_double_src_operand,
    "r,CalE,m,r",
    E_V4HImode,
    0,
    0,
    1,
    1
  },
  {
    move_dest_operand,
    "=r,r,r,m",
    E_V8QImode,
    0,
    0,
    1,
    1
  },
  {
    move_double_src_operand,
    "r,CalE,m,r",
    E_V8QImode,
    0,
    0,
    1,
    1
  },
  {
    move_dest_operand,
    "=r,r,r,m",
    E_SFmode,
    0,
    0,
    1,
    1
  },
  {
    move_src_operand,
    "r,E,m,r",
    E_SFmode,
    0,
    0,
    1,
    1
  },
  {
    add_reg_operand,
    "=r,r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    add_reg_operand,
    "%r,r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    add_operand,
    "rL,CnL",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    gpr_operand,
    "=r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    gpr_operand,
    "%r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    nonmemory_operand,
    "rCar",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    gpr_operand,
    "=r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    add_reg_operand,
    "r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    arith_operand,
    "rL",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    gpr_operand,
    "=r",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    gpr_operand,
    "%r",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    gpr_operand,
    "r",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    float_operation,
    "",
    E_VOIDmode,
    0,
    1,
    0,
    0
  },
  {
    gpr_operand,
    "=r",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    gpr_operand,
    "r",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    gpr_operand,
    "r",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    float_operation,
    "",
    E_VOIDmode,
    0,
    1,
    0,
    0
  },
  {
    gpr_operand,
    "=r,r",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    const_float_1_operand,
    "",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    move_src_operand,
    "rU16m,rU16mCal",
    E_SFmode,
    0,
    0,
    1,
    1
  },
  {
    move_src_operand,
    "rU16m,rU16mCal",
    E_SImode,
    0,
    0,
    1,
    1
  },
  {
    float_operation,
    "",
    E_VOIDmode,
    0,
    1,
    0,
    0
  },
  {
    const_float_1_operand,
    "",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    float_operation,
    "",
    E_VOIDmode,
    0,
    1,
    0,
    0
  },
  {
    gpr_operand,
    "=r",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    gpr_operand,
    "r",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    gpr_operand,
    "r",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    gpr_operand,
    "0",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    float_operation,
    "",
    E_VOIDmode,
    0,
    1,
    0,
    0
  },
  {
    gpr_operand,
    "=r",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    gpr_operand,
    "r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    float_operation,
    "",
    E_VOIDmode,
    0,
    1,
    0,
    0
  },
  {
    gpr_operand,
    "=r",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    gpr_operand,
    "r",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    const0_operand,
    "",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    float_operation,
    "",
    E_VOIDmode,
    0,
    1,
    0,
    0
  },
  {
    gpr_operand,
    "=r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    gpr_operand,
    "r",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    float_operation,
    "",
    E_VOIDmode,
    0,
    1,
    0,
    0
  },
  {
    gpr_operand,
    "=r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    gpr_operand,
    "%r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    gpr_operand,
    "r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    float_operation,
    "",
    E_VOIDmode,
    0,
    1,
    0,
    0
  },
  {
    gpr_operand,
    "=r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    gpr_operand,
    "r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    gpr_operand,
    "r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    float_operation,
    "",
    E_VOIDmode,
    0,
    1,
    0,
    0
  },
  {
    gpr_operand,
    "=r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    gpr_operand,
    "r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    gpr_operand,
    "r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    gpr_operand,
    "0",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    float_operation,
    "",
    E_VOIDmode,
    0,
    1,
    0,
    0
  },
  {
    move_dest_operand,
    "=r,r",
    E_SImode,
    0,
    0,
    1,
    1
  },
  {
    move_src_operand,
    "rU16m,rU16mCal",
    E_SImode,
    0,
    0,
    1,
    1
  },
  {
    move_src_operand,
    "rU16m,rU16mCal",
    E_SImode,
    0,
    0,
    1,
    1
  },
  {
    call_address_operand,
    "Csy,r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    float_operation,
    "",
    E_VOIDmode,
    0,
    1,
    0,
    0
  },
  {
    cc_move_operand,
    "=r,Rcc",
    E_CCmode,
    0,
    0,
    1,
    0
  },
  {
    cc_move_operand,
    "Rcc,r",
    E_CCmode,
    0,
    0,
    1,
    0
  },
  {
    nonmemory_operand,
    "X,r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    scratch_operand,
    "=X,&r",
    E_SImode,
    0,
    0,
    0,
    0
  },
  {
    set_fp_mode_operand,
    "rCfm",
    E_SImode,
    0,
    0,
    1,
    1
  },
  {
    set_fp_mode_operand,
    "rCfm",
    E_SImode,
    0,
    0,
    1,
    1
  },
  {
    gpr_operand,
    "r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    scratch_operand,
    "=&r",
    E_SImode,
    0,
    0,
    0,
    0
  },
  {
    gpr_operand,
    "=r,r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    gpr_operand,
    "r,r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    arith_operand,
    "r,K",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    scratch_operand,
    "=r",
    E_SImode,
    0,
    0,
    0,
    0
  },
  {
    gpr_operand,
    "r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    const_int_operand,
    "K",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "=r,r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    nonimmediate_operand,
    "r,m",
    E_QImode,
    0,
    0,
    1,
    1
  },
  {
    register_operand,
    "=r,r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    nonimmediate_operand,
    "0,m",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    add_reg_operand,
    "r,r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    arith_operand,
    "r,L",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    scratch_operand,
    "=r,r",
    E_SImode,
    0,
    0,
    0,
    0
  },
  {
    gpr_operand,
    "=r,r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    gpr_operand,
    "r,r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    arith_operand,
    "r,L",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    gpr_operand,
    "=r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    gpr_operand,
    "r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    arith_int_operand,
    "L",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    const_int_operand,
    "CnL",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    gpr_operand,
    "=r,r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    gpr_operand,
    "%r,r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    arith_operand,
    "r,L",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    scratch_operand,
    "=r,r",
    E_SImode,
    0,
    0,
    0,
    0
  },
  {
    gpr_operand,
    "r,r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    arith_operand,
    "r,L",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    gpr_operand,
    "r",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    gpr_operand,
    "r",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    scratch_operand,
    "=r",
    E_SFmode,
    0,
    0,
    0,
    0
  },
  {
    float_operation,
    "",
    E_VOIDmode,
    0,
    1,
    0,
    0
  },
  {
    gpr_operand,
    "=r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    gpr_operand,
    "r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    gpr_operand,
    "0",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    proper_comparison_operator,
    "",
    E_VOIDmode,
    0,
    1,
    0,
    0
  },
  {
    cc_operand,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    gpr_operand,
    "=r",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    gpr_operand,
    "r",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    gpr_operand,
    "0",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    proper_comparison_operator,
    "",
    E_VOIDmode,
    0,
    1,
    0,
    0
  },
  {
    cc_operand,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    gpr_operand,
    "=r",
    E_HImode,
    0,
    0,
    1,
    0
  },
  {
    gpr_operand,
    "r",
    E_HImode,
    0,
    0,
    1,
    0
  },
  {
    gpr_operand,
    "0",
    E_HImode,
    0,
    0,
    1,
    0
  },
  {
    proper_comparison_operator,
    "",
    E_VOIDmode,
    0,
    1,
    0,
    0
  },
  {
    cc_operand,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    gpr_operand,
    "=r",
    E_QImode,
    0,
    0,
    1,
    0
  },
  {
    gpr_operand,
    "r",
    E_QImode,
    0,
    0,
    1,
    0
  },
  {
    gpr_operand,
    "0",
    E_QImode,
    0,
    0,
    1,
    0
  },
  {
    proper_comparison_operator,
    "",
    E_VOIDmode,
    0,
    1,
    0,
    0
  },
  {
    cc_operand,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    gpr_operand,
    "=r",
    E_V2HImode,
    0,
    0,
    1,
    0
  },
  {
    gpr_operand,
    "r",
    E_V2HImode,
    0,
    0,
    1,
    0
  },
  {
    gpr_operand,
    "0",
    E_V2HImode,
    0,
    0,
    1,
    0
  },
  {
    proper_comparison_operator,
    "",
    E_VOIDmode,
    0,
    1,
    0,
    0
  },
  {
    cc_operand,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    gpr_operand,
    "=r",
    E_V4QImode,
    0,
    0,
    1,
    0
  },
  {
    gpr_operand,
    "r",
    E_V4QImode,
    0,
    0,
    1,
    0
  },
  {
    gpr_operand,
    "0",
    E_V4QImode,
    0,
    0,
    1,
    0
  },
  {
    proper_comparison_operator,
    "",
    E_VOIDmode,
    0,
    1,
    0,
    0
  },
  {
    cc_operand,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    proper_comparison_operator,
    "",
    E_VOIDmode,
    0,
    1,
    0,
    0
  },
  {
    cc_operand,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    gpr_operand,
    "r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    gpr_operand,
    "r",
    E_HImode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    call_address_operand,
    "Csy,r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    float_operation,
    "",
    E_VOIDmode,
    0,
    1,
    0,
    0
  },
  {
    call_address_operand,
    "Csy,Rsc",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    gpr_operand,
    "=r,r",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    call_address_operand,
    "Csy,r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    float_operation,
    "",
    E_VOIDmode,
    0,
    1,
    0,
    0
  },
  {
    gpr_operand,
    "=r,r",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    call_address_operand,
    "Csy,Rsc",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    arith_operand,
    "rL",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    memclob_operand,
    "=X",
    E_BLKmode,
    0,
    0,
    1,
    1
  },
  {
    memory_operand,
    "=m",
    E_BLKmode,
    0,
    0,
    1,
    1
  },
  {
    stacktop_operand,
    "=m",
    E_VOIDmode,
    0,
    0,
    1,
    1
  },
  {
    any_gpr_operand,
    "r",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    nonmemory_operand,
    "rn",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    memclob_operand,
    "=X",
    E_BLKmode,
    0,
    0,
    1,
    1
  },
  {
    gpr_operand,
    "=r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    stacktop_operand,
    "m",
    E_SImode,
    0,
    0,
    1,
    1
  },
  {
    nonmemory_operand,
    "rn",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    memory_operand,
    "=m",
    E_BLKmode,
    0,
    0,
    1,
    1
  },
  {
    gpr_operand,
    "=r",
    E_V2SImode,
    0,
    0,
    1,
    0
  },
  {
    gpr_operand,
    "r",
    E_V2SImode,
    0,
    0,
    1,
    0
  },
  {
    gpr_operand,
    "r",
    E_V2SImode,
    0,
    0,
    1,
    0
  },
  {
    gpr_operand,
    "=r",
    E_V2SFmode,
    0,
    0,
    1,
    0
  },
  {
    gpr_operand,
    "r",
    E_V2SFmode,
    0,
    0,
    1,
    0
  },
  {
    gpr_operand,
    "r",
    E_V2SFmode,
    0,
    0,
    1,
    0
  },
  {
    float_operation,
    "",
    E_VOIDmode,
    0,
    1,
    0,
    0
  },
  {
    gpr_operand,
    "=&r,*1*2",
    E_V2SImode,
    0,
    0,
    1,
    0
  },
  {
    gpr_operand,
    "r,r",
    E_V2SImode,
    0,
    0,
    1,
    0
  },
  {
    const_int_operand,
    "n,n",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    float_operation,
    "",
    E_VOIDmode,
    0,
    1,
    0,
    0
  },
  {
    gpr_operand,
    "r,r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    gpr_operand,
    "=r",
    E_V2SImode,
    0,
    0,
    1,
    0
  },
  {
    gpr_operand,
    "r",
    E_V2SImode,
    0,
    0,
    1,
    0
  },
  {
    gpr_operand,
    "r",
    E_V2SImode,
    0,
    0,
    1,
    0
  },
  {
    float_operation,
    "",
    E_VOIDmode,
    0,
    1,
    0,
    0
  },
  {
    gpr_operand,
    "=r",
    E_V2SImode,
    0,
    0,
    1,
    0
  },
  {
    gpr_operand,
    "r",
    E_V2SImode,
    0,
    0,
    1,
    0
  },
  {
    gpr_operand,
    "r",
    E_V2SImode,
    0,
    0,
    1,
    0
  },
  {
    gpr_operand,
    "0",
    E_V2SImode,
    0,
    0,
    1,
    0
  },
  {
    float_operation,
    "",
    E_VOIDmode,
    0,
    1,
    0,
    0
  },
  {
    gpr_operand,
    "=r",
    E_V2SFmode,
    0,
    0,
    1,
    0
  },
  {
    gpr_operand,
    "r",
    E_V2SFmode,
    0,
    0,
    1,
    0
  },
  {
    gpr_operand,
    "r",
    E_V2SFmode,
    0,
    0,
    1,
    0
  },
  {
    gpr_operand,
    "0",
    E_V2SFmode,
    0,
    0,
    1,
    0
  },
  {
    float_operation,
    "",
    E_VOIDmode,
    0,
    1,
    0,
    0
  },
  {
    general_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "",
    E_SFmode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "",
    E_SFmode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "",
    E_HImode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "",
    E_QImode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "",
    E_QImode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "",
    E_V2HImode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "",
    E_V2HImode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "",
    E_V4QImode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "",
    E_V4QImode,
    0,
    0,
    1,
    1
  },
  {
    gpr_operand,
    "r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "Sra",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    general_operand,
    "",
    E_DImode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "",
    E_DImode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "",
    E_DFmode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "",
    E_DFmode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "",
    E_V2SImode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "",
    E_V2SImode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "",
    E_V2SFmode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "",
    E_V2SFmode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "",
    E_V4HImode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "",
    E_V4HImode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "",
    E_V8QImode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "",
    E_V8QImode,
    0,
    0,
    1,
    1
  },
  {
    add_reg_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    add_reg_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    add_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    gpr_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    add_reg_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    arith_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    gpr_operand,
    "",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    gpr_operand,
    "",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    gpr_operand,
    "",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    const_float_1_operand,
    "",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    move_src_operand,
    "",
    E_SFmode,
    0,
    0,
    1,
    1
  },
  {
    move_src_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    1
  },
  {
    gpr_operand,
    "",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    gpr_operand,
    "",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    gpr_operand,
    "",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    gpr_operand,
    "",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    gpr_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    gpr_operand,
    "",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    gpr_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    gpr_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    gpr_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    move_dest_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    1
  },
  {
    move_src_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    1
  },
  {
    move_src_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    1
  },
  {
    cc_move_operand,
    "",
    E_CCmode,
    0,
    0,
    1,
    0
  },
  {
    cc_move_operand,
    "",
    E_CCmode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    1,
    0,
    0
  },
  {
    scratch_operand,
    "=X,&r",
    E_SImode,
    0,
    0,
    0,
    0
  },
  {
    gpr_operand,
    "=r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    nonmemory_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    gpr_operand,
    "=r",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    comparison_operator,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    arith_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    gpr_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    comparison_operator,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    gpr_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    gpr_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    gpr_operand,
    "",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    comparison_operator,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    gpr_operand,
    "",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    gpr_operand,
    "",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    gpr_operand,
    "",
    E_HImode,
    0,
    0,
    1,
    0
  },
  {
    comparison_operator,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    gpr_operand,
    "",
    E_HImode,
    0,
    0,
    1,
    0
  },
  {
    gpr_operand,
    "",
    E_HImode,
    0,
    0,
    1,
    0
  },
  {
    gpr_operand,
    "",
    E_QImode,
    0,
    0,
    1,
    0
  },
  {
    comparison_operator,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    gpr_operand,
    "",
    E_QImode,
    0,
    0,
    1,
    0
  },
  {
    gpr_operand,
    "",
    E_QImode,
    0,
    0,
    1,
    0
  },
  {
    gpr_operand,
    "",
    E_V2HImode,
    0,
    0,
    1,
    0
  },
  {
    comparison_operator,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    gpr_operand,
    "",
    E_V2HImode,
    0,
    0,
    1,
    0
  },
  {
    gpr_operand,
    "",
    E_V2HImode,
    0,
    0,
    1,
    0
  },
  {
    gpr_operand,
    "",
    E_V4QImode,
    0,
    0,
    1,
    0
  },
  {
    comparison_operator,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    gpr_operand,
    "",
    E_V4QImode,
    0,
    0,
    1,
    0
  },
  {
    gpr_operand,
    "",
    E_V4QImode,
    0,
    0,
    1,
    0
  },
  {
    ordered_comparison_operator,
    "",
    E_VOIDmode,
    0,
    1,
    0,
    0
  },
  {
    add_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    arith_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    comparison_operator,
    "",
    E_VOIDmode,
    0,
    1,
    0,
    0
  },
  {
    arith_operand,
    "",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    arith_operand,
    "",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    gpr_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    call_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    1
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    gpr_operand,
    "=r",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    call_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    1
  },
  {
    0,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    gpr_operand,
    "",
    E_V2SImode,
    0,
    0,
    1,
    0
  },
  {
    gpr_operand,
    "",
    E_V4HImode,
    0,
    0,
    1,
    0
  },
  {
    gpr_operand,
    "",
    E_V2SFmode,
    0,
    0,
    1,
    0
  },
  {
    gpr_operand,
    "",
    E_V2SFmode,
    0,
    0,
    1,
    0
  },
  {
    gpr_operand,
    "",
    E_V2SFmode,
    0,
    0,
    1,
    0
  },
  {
    gpr_operand,
    "",
    E_V2SImode,
    0,
    0,
    1,
    0
  },
  {
    gpr_operand,
    "",
    E_V2SImode,
    0,
    0,
    1,
    0
  },
  {
    general_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    1
  },
  {
    gpr_operand,
    "",
    E_V2SImode,
    0,
    0,
    1,
    0
  },
  {
    gpr_operand,
    "",
    E_V2SImode,
    0,
    0,
    1,
    0
  },
  {
    gpr_operand,
    "",
    E_V2SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    E_V2SImode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    E_SImode,
    0,
    0,
    1,
    0
  },
  {
    const_int_operand,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    E_V2SFmode,
    0,
    0,
    1,
    0
  },
  {
    register_operand,
    "",
    E_SFmode,
    0,
    0,
    1,
    0
  },
  {
    const_int_operand,
    "",
    E_VOIDmode,
    0,
    0,
    1,
    0
  },
  {
    nonimmediate_operand,
    "",
    E_V2SImode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "",
    E_V2SImode,
    0,
    0,
    1,
    1
  },
  {
    nonimmediate_operand,
    "",
    E_V2SFmode,
    0,
    0,
    1,
    1
  },
  {
    general_operand,
    "",
    E_V2SFmode,
    0,
    0,
    1,
    1
  },
};


#if GCC_VERSION >= 2007
__extension__
#endif

const struct insn_data_d insn_data[] = 
{
  /* <internal>:0 */
  {
    "*placeholder_for_nothing",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { 0 },
    &operand_data[0],
    0,
    0,
    0,
    0,
    0
  },
  /* ../../gcc/config/epiphany/epiphany.md:140 */
  {
    "*movqi_insn",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_1 },
#else
    { 0, output_1, 0 },
#endif
    { 0 },
    &operand_data[1],
    2,
    2,
    0,
    5,
    2
  },
  /* ../../gcc/config/epiphany/epiphany.md:154 */
  {
    "*movhi_insn",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_2 },
#else
    { 0, output_2, 0 },
#endif
    { 0 },
    &operand_data[3],
    2,
    2,
    0,
    4,
    2
  },
  /* ../../gcc/config/epiphany/epiphany.md:183 */
  {
    "move_frame",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_move_frame },
    &operand_data[5],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../gcc/config/epiphany/epiphany.md:190 */
  {
    "movsi_high",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "movt %0, %%high(%1)",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movsi_high },
    &operand_data[7],
    2,
    2,
    1,
    1,
    1
  },
  /* ../../gcc/config/epiphany/epiphany.md:199 */
  {
    "movsi_lo_sum",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "mov %0, %%low(%1)",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movsi_lo_sum },
    &operand_data[9],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../gcc/config/epiphany/epiphany.md:208 */
  {
    "*movsi_insn",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_6 },
#else
    { 0, 0, output_6 },
#endif
    { 0 },
    &operand_data[11],
    2,
    2,
    0,
    9,
    3
  },
  /* ../../gcc/config/epiphany/epiphany.md:289 */
  {
    "*move_frame_1",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[13],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../gcc/config/epiphany/epiphany.md:357 */
  {
    "*movdi_insn",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_8 },
#else
    { 0, output_8, 0 },
#endif
    { 0 },
    &operand_data[15],
    2,
    2,
    0,
    4,
    2
  },
  /* ../../gcc/config/epiphany/epiphany.md:357 */
  {
    "*movdf_insn",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_9 },
#else
    { 0, output_9, 0 },
#endif
    { 0 },
    &operand_data[17],
    2,
    2,
    0,
    4,
    2
  },
  /* ../../gcc/config/epiphany/epiphany.md:357 */
  {
    "*movv2si_insn",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_10 },
#else
    { 0, output_10, 0 },
#endif
    { 0 },
    &operand_data[19],
    2,
    2,
    0,
    4,
    2
  },
  /* ../../gcc/config/epiphany/epiphany.md:357 */
  {
    "*movv2sf_insn",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_11 },
#else
    { 0, output_11, 0 },
#endif
    { 0 },
    &operand_data[21],
    2,
    2,
    0,
    4,
    2
  },
  /* ../../gcc/config/epiphany/epiphany.md:357 */
  {
    "*movv4hi_insn",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_12 },
#else
    { 0, output_12, 0 },
#endif
    { 0 },
    &operand_data[23],
    2,
    2,
    0,
    4,
    2
  },
  /* ../../gcc/config/epiphany/epiphany.md:357 */
  {
    "*movv8qi_insn",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_13 },
#else
    { 0, output_13, 0 },
#endif
    { 0 },
    &operand_data[25],
    2,
    2,
    0,
    4,
    2
  },
  /* ../../gcc/config/epiphany/epiphany.md:400 */
  {
    "*movsf_insn",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_14 },
#else
    { 0, output_14, 0 },
#endif
    { 0 },
    &operand_data[27],
    2,
    2,
    0,
    4,
    2
  },
  /* ../../gcc/config/epiphany/epiphany.md:437 */
  {
    "addsi3_i",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_15 },
#else
    { 0, output_15, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_addsi3_i },
    &operand_data[29],
    3,
    3,
    0,
    2,
    2
  },
  /* ../../gcc/config/epiphany/epiphany.md:454 */
  {
    "addsi3_r",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_16 },
#else
    { 0, 0, output_16 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_addsi3_r },
    &operand_data[32],
    3,
    3,
    0,
    1,
    3
  },
  /* ../../gcc/config/epiphany/epiphany.md:578 */
  {
    "subsi3_i",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "sub %0,%1,%2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_subsi3_i },
    &operand_data[35],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc/config/epiphany/epiphany.md:604 */
  {
    "*addsf3_i",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "fadd %0,%1,%2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[38],
    4,
    4,
    0,
    1,
    1
  },
  /* ../../gcc/config/epiphany/epiphany.md:622 */
  {
    "*subsf3_i",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "fsub %0,%1,%2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[42],
    4,
    4,
    0,
    1,
    1
  },
  /* ../../gcc/config/epiphany/epiphany.md:641 */
  {
    "*subsf3_f_i",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "fsub %0,%1,%2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[42],
    4,
    4,
    2,
    1,
    1
  },
  /* ../../gcc/config/epiphany/epiphany.md:676 */
  {
    "*mulsf3_i",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "fmul %0,%1,%2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[38],
    4,
    4,
    0,
    1,
    1
  },
  /* ../../gcc/config/epiphany/epiphany.md:732 */
  {
    "*recipsf2_1",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[46],
    5,
    5,
    0,
    2,
    1
  },
  /* ../../gcc/config/epiphany/epiphany.md:772 */
  {
    "*recipsf2_2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "jalr r1",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[51],
    2,
    2,
    0,
    0,
    1
  },
  /* ../../gcc/config/epiphany/epiphany.md:802 */
  {
    "*fmadd",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "fmadd %0,%1,%2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[53],
    5,
    5,
    0,
    1,
    1
  },
  /* ../../gcc/config/epiphany/epiphany.md:829 */
  {
    "*maddsf_combine",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "fmadd %0,%1,%2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[53],
    5,
    5,
    0,
    1,
    1
  },
  /* ../../gcc/config/epiphany/epiphany.md:850 */
  {
    "*fmsub",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "fmsub %0,%1,%2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[53],
    5,
    5,
    0,
    1,
    1
  },
  /* ../../gcc/config/epiphany/epiphany.md:861 */
  {
    "*fmsub_combine",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "fmsub %0,%1,%2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[53],
    5,
    5,
    0,
    1,
    1
  },
  /* ../../gcc/config/epiphany/epiphany.md:880 */
  {
    "*floatsisf2_i",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "float %0, %1",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[58],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc/config/epiphany/epiphany.md:899 */
  {
    "*floatsisf2_cmp_i",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "float %0, %1",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[61],
    4,
    4,
    1,
    1,
    1
  },
  /* ../../gcc/config/epiphany/epiphany.md:936 */
  {
    "*fix_truncsfsi2_i",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "fix %0, %1",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[65],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc/config/epiphany/epiphany.md:1005 */
  {
    "*iadd_i",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "iadd %0, %1, %2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[68],
    4,
    4,
    0,
    1,
    1
  },
  /* ../../gcc/config/epiphany/epiphany.md:1022 */
  {
    "*isub_i",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "isub %0, %1, %2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[72],
    4,
    4,
    0,
    1,
    1
  },
  /* ../../gcc/config/epiphany/epiphany.md:1090 */
  {
    "*imul",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "imul %0, %1, %2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[68],
    4,
    4,
    0,
    1,
    1
  },
  /* ../../gcc/config/epiphany/epiphany.md:1110 */
  {
    "*maddsi_combine",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "imadd %0, %1, %2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[76],
    5,
    5,
    0,
    1,
    1
  },
  /* ../../gcc/config/epiphany/epiphany.md:1121 */
  {
    "*imsub",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "imsub %0, %1, %2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[76],
    5,
    5,
    0,
    1,
    1
  },
  /* ../../gcc/config/epiphany/epiphany.md:1152 */
  {
    "*divsi3_1",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[81],
    5,
    5,
    0,
    2,
    1
  },
  /* ../../gcc/config/epiphany/epiphany.md:1191 */
  {
    "*divsi3_2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "%f0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[84],
    2,
    2,
    0,
    2,
    1
  },
  /* ../../gcc/config/epiphany/epiphany.md:1226 */
  {
    "*udivsi3_1",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[81],
    5,
    5,
    0,
    2,
    1
  },
  /* ../../gcc/config/epiphany/epiphany.md:1263 */
  {
    "*udivsi3_2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "%f0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[84],
    2,
    2,
    0,
    2,
    1
  },
  /* ../../gcc/config/epiphany/epiphany.md:1298 */
  {
    "*modsi3_1",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[81],
    5,
    5,
    0,
    2,
    1
  },
  /* ../../gcc/config/epiphany/epiphany.md:1336 */
  {
    "*modsi3_2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "%f0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[84],
    2,
    2,
    0,
    2,
    1
  },
  /* ../../gcc/config/epiphany/epiphany.md:1370 */
  {
    "*umodsi3_1",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[81],
    5,
    5,
    0,
    2,
    1
  },
  /* ../../gcc/config/epiphany/epiphany.md:1406 */
  {
    "*umodsi3_2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "%f0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[84],
    2,
    2,
    0,
    2,
    1
  },
  /* ../../gcc/config/epiphany/epiphany.md:1423 */
  {
    "gid",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "gid",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_gid },
    &operand_data[0],
    0,
    0,
    0,
    0,
    1
  },
  /* ../../gcc/config/epiphany/epiphany.md:1434 */
  {
    "gie",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "gie",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_gie },
    &operand_data[0],
    0,
    0,
    0,
    0,
    1
  },
  /* ../../gcc/config/epiphany/epiphany.md:1461 */
  {
    "*movcc_i",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_46 },
#else
    { 0, output_46, 0 },
#endif
    { 0 },
    &operand_data[86],
    3,
    4,
    0,
    2,
    2
  },
  /* ../../gcc/config/epiphany/epiphany.md:1473 */
  {
    "save_config",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_save_config },
    &operand_data[5],
    1,
    1,
    0,
    1,
    1
  },
  /* ../../gcc/config/epiphany/epiphany.md:1483 */
  {
    "set_fp_mode",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_set_fp_mode },
    &operand_data[90],
    3,
    4,
    1,
    1,
    1
  },
  /* ../../gcc/config/epiphany/epiphany.md:1509 */
  {
    "andsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "and %0,%1,%2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_andsi3 },
    &operand_data[72],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc/config/epiphany/epiphany.md:1517 */
  {
    "iorsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "orr %0,%1,%2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_iorsi3 },
    &operand_data[72],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc/config/epiphany/epiphany.md:1525 */
  {
    "xorsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "eor %0,%1,%2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_xorsi3 },
    &operand_data[72],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc/config/epiphany/epiphany.md:1549 */
  {
    "one_cmplsi2_i",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "eor %0,%1,%-",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_one_cmplsi2_i },
    &operand_data[13],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../gcc/config/epiphany/epiphany.md:1560 */
  {
    "ashrsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "asr %0,%1,%2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_ashrsi3 },
    &operand_data[94],
    3,
    3,
    0,
    2,
    1
  },
  /* ../../gcc/config/epiphany/epiphany.md:1570 */
  {
    "ashrsi3_tst",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "asr %0,%1,%2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_ashrsi3_tst },
    &operand_data[94],
    3,
    3,
    2,
    2,
    1
  },
  /* ../../gcc/config/epiphany/epiphany.md:1584 */
  {
    "lshrsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "lsr %0,%1,%2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_lshrsi3 },
    &operand_data[94],
    3,
    3,
    0,
    2,
    1
  },
  /* ../../gcc/config/epiphany/epiphany.md:1594 */
  {
    "lshrsi3_tst",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "lsr %0,%1,%2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_lshrsi3_tst },
    &operand_data[94],
    3,
    3,
    2,
    2,
    1
  },
  /* ../../gcc/config/epiphany/epiphany.md:1608 */
  {
    "ashlsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "lsl %0,%1,%2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_ashlsi3 },
    &operand_data[94],
    3,
    3,
    0,
    2,
    1
  },
  /* ../../gcc/config/epiphany/epiphany.md:1618 */
  {
    "*ashlsi_btst",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_58 },
#else
    { 0, 0, output_58 },
#endif
    { 0 },
    &operand_data[97],
    3,
    3,
    0,
    1,
    3
  },
  /* ../../gcc/config/epiphany/epiphany.md:1638 */
  {
    "zero_extendqisi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_59 },
#else
    { 0, output_59, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_zero_extendqisi2 },
    &operand_data[100],
    2,
    2,
    0,
    2,
    2
  },
  /* ../../gcc/config/epiphany/epiphany.md:1655 */
  {
    "zero_extendhisi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_60 },
#else
    { 0, output_60, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_zero_extendhisi2 },
    &operand_data[102],
    2,
    2,
    0,
    2,
    2
  },
  /* ../../gcc/config/epiphany/epiphany.md:1666 */
  {
    "cmpsi_cc_insn",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "sub %2,%0,%1",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_cmpsi_cc_insn },
    &operand_data[104],
    2,
    3,
    0,
    2,
    1
  },
  /* ../../gcc/config/epiphany/epiphany.md:1675 */
  {
    "sub_f",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "sub %0,%1,%2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sub_f },
    &operand_data[107],
    3,
    3,
    2,
    2,
    1
  },
  /* ../../gcc/config/epiphany/epiphany.md:1685 */
  {
    "*sub_f_add_imm",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "sub %0,%1,%2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[110],
    4,
    4,
    1,
    1,
    1
  },
  /* ../../gcc/config/epiphany/epiphany.md:1709 */
  {
    "*add_c",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "add %0,%1,%2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[114],
    3,
    3,
    3,
    2,
    1
  },
  /* ../../gcc/config/epiphany/epiphany.md:1721 */
  {
    "*add_c_rev",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "add %0,%1,%2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[114],
    3,
    3,
    3,
    2,
    1
  },
  /* ../../gcc/config/epiphany/epiphany.md:1733 */
  {
    "*sub_c",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "sub %0,%1,%2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[107],
    3,
    3,
    3,
    2,
    1
  },
  /* ../../gcc/config/epiphany/epiphany.md:1745 */
  {
    "*sub_c_void",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "sub %0,%1,%2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[117],
    3,
    3,
    1,
    2,
    1
  },
  /* ../../gcc/config/epiphany/epiphany.md:1762 */
  {
    "*and_f",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "and %0,%1,%2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[68],
    3,
    3,
    2,
    1,
    1
  },
  /* ../../gcc/config/epiphany/epiphany.md:1762 */
  {
    "*orr_f",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "orr %0,%1,%2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[68],
    3,
    3,
    2,
    1,
    1
  },
  /* ../../gcc/config/epiphany/epiphany.md:1762 */
  {
    "*eor_f",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "eor %0,%1,%2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[68],
    3,
    3,
    2,
    1,
    1
  },
  /* ../../gcc/config/epiphany/epiphany.md:1773 */
  {
    "*mov_f",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[13],
    2,
    2,
    1,
    1,
    1
  },
  /* ../../gcc/config/epiphany/epiphany.md:1884 */
  {
    "*cmpsf_cc_insn",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "fsub %2,%0,%1",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[120],
    4,
    4,
    0,
    1,
    1
  },
  /* ../../gcc/config/epiphany/epiphany.md:1900 */
  {
    "*cmpsf_eq",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "%f0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[84],
    1,
    1,
    0,
    2,
    1
  },
  /* ../../gcc/config/epiphany/epiphany.md:1909 */
  {
    "*cmpsf_gte",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "%f0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[84],
    1,
    1,
    0,
    2,
    1
  },
  /* ../../gcc/config/epiphany/epiphany.md:1918 */
  {
    "*cmpsf_ord",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "%f0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[84],
    1,
    1,
    0,
    2,
    1
  },
  /* ../../gcc/config/epiphany/epiphany.md:1928 */
  {
    "*cmpsf_uneq",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "%f0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[84],
    1,
    1,
    0,
    2,
    1
  },
  /* ../../gcc/config/epiphany/epiphany.md:1993 */
  {
    "*movsicc_insn",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "mov%d3 %0,%1",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[124],
    5,
    5,
    0,
    1,
    1
  },
  /* ../../gcc/config/epiphany/epiphany.md:1993 */
  {
    "*movsfcc_insn",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "mov%d3 %0,%1",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[129],
    5,
    5,
    0,
    1,
    1
  },
  /* ../../gcc/config/epiphany/epiphany.md:1993 */
  {
    "*movhicc_insn",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "mov%d3 %0,%1",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[134],
    5,
    5,
    0,
    1,
    1
  },
  /* ../../gcc/config/epiphany/epiphany.md:1993 */
  {
    "*movqicc_insn",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "mov%d3 %0,%1",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[139],
    5,
    5,
    0,
    1,
    1
  },
  /* ../../gcc/config/epiphany/epiphany.md:1993 */
  {
    "*movv2hicc_insn",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "mov%d3 %0,%1",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[144],
    5,
    5,
    0,
    1,
    1
  },
  /* ../../gcc/config/epiphany/epiphany.md:1993 */
  {
    "*movv4qicc_insn",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "mov%d3 %0,%1",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[149],
    5,
    5,
    0,
    1,
    1
  },
  /* ../../gcc/config/epiphany/epiphany.md:2107 */
  {
    "branch_insn",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "b%d1 %l0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_branch_insn },
    &operand_data[154],
    3,
    3,
    0,
    0,
    1
  },
  /* ../../gcc/config/epiphany/epiphany.md:2118 */
  {
    "*rev_branch_insn",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "b%D1 %l0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[154],
    2,
    2,
    0,
    0,
    1
  },
  /* ../../gcc/config/epiphany/epiphany.md:2130 */
  {
    "jump",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "b %l0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_jump },
    &operand_data[154],
    1,
    1,
    0,
    0,
    1
  },
  /* ../../gcc/config/epiphany/epiphany.md:2136 */
  {
    "indirect_jump",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "jr %0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_indirect_jump },
    &operand_data[14],
    1,
    1,
    0,
    1,
    1
  },
  /* ../../gcc/config/epiphany/epiphany.md:2158 */
  {
    "*tablejump_internal",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "jr %0;",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[157],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../gcc/config/epiphany/epiphany.md:2165 */
  {
    "*tablejump_hi_internal",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "jr %0;",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[159],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../gcc/config/epiphany/epiphany.md:2202 */
  {
    "*call_i",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "%f0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[161],
    3,
    3,
    0,
    2,
    1
  },
  /* ../../gcc/config/epiphany/epiphany.md:2239 */
  {
    "*sibcall_i",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_90 },
#else
    { 0, output_90, 0 },
#endif
    { 0 },
    &operand_data[164],
    2,
    2,
    0,
    2,
    2
  },
  /* ../../gcc/config/epiphany/epiphany.md:2281 */
  {
    "*call_value_i",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "%f1",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[166],
    4,
    4,
    0,
    2,
    1
  },
  /* ../../gcc/config/epiphany/epiphany.md:2323 */
  {
    "*sibcall_value_i",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .multi = output_92 },
#else
    { 0, output_92, 0 },
#endif
    { 0 },
    &operand_data[170],
    3,
    3,
    0,
    2,
    2
  },
  /* ../../gcc/config/epiphany/epiphany.md:2365 */
  {
    "return_i",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "rts",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_return_i },
    &operand_data[0],
    0,
    0,
    0,
    0,
    1
  },
  /* ../../gcc/config/epiphany/epiphany.md:2371 */
  {
    "return_internal_interrupt",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "rti",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_return_internal_interrupt },
    &operand_data[0],
    0,
    0,
    0,
    0,
    1
  },
  /* ../../gcc/config/epiphany/epiphany.md:2378 */
  {
    "stack_adjust_add",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "add sp,sp,%0",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_stack_adjust_add },
    &operand_data[173],
    2,
    2,
    0,
    1,
    1
  },
  /* ../../gcc/config/epiphany/epiphany.md:2387 */
  {
    "stack_adjust_mov",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "mov sp,fp",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_stack_adjust_mov },
    &operand_data[175],
    1,
    1,
    0,
    1,
    1
  },
  /* ../../gcc/config/epiphany/epiphany.md:2394 */
  {
    "stack_adjust_str",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .function = output_97 },
#else
    { 0, 0, output_97 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_stack_adjust_str },
    &operand_data[176],
    4,
    4,
    0,
    1,
    3
  },
  /* ../../gcc/config/epiphany/epiphany.md:2407 */
  {
    "stack_adjust_ldr",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "ldr %0,%1,%C2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_stack_adjust_ldr },
    &operand_data[180],
    4,
    4,
    0,
    1,
    1
  },
  /* ../../gcc/config/epiphany/epiphany.md:2473 */
  {
    "addv2si3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_addv2si3 },
    &operand_data[184],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc/config/epiphany/epiphany.md:2473 */
  {
    "subv2si3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_subv2si3 },
    &operand_data[184],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc/config/epiphany/epiphany.md:2473 */
  {
    "andv2si3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_andv2si3 },
    &operand_data[184],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc/config/epiphany/epiphany.md:2473 */
  {
    "iorv2si3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_iorv2si3 },
    &operand_data[184],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc/config/epiphany/epiphany.md:2473 */
  {
    "xorv2si3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_xorv2si3 },
    &operand_data[184],
    3,
    3,
    0,
    1,
    1
  },
  /* ../../gcc/config/epiphany/epiphany.md:2508 */
  {
    "addv2sf3_i",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_addv2sf3_i },
    &operand_data[187],
    4,
    4,
    0,
    1,
    1
  },
  /* ../../gcc/config/epiphany/epiphany.md:2508 */
  {
    "subv2sf3_i",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_subv2sf3_i },
    &operand_data[187],
    4,
    4,
    0,
    1,
    1
  },
  /* ../../gcc/config/epiphany/epiphany.md:2595 */
  {
    "*ashlv2si3_i",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[191],
    5,
    5,
    0,
    2,
    1
  },
  /* ../../gcc/config/epiphany/epiphany.md:2662 */
  {
    "mulv2si3_i",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_mulv2si3_i },
    &operand_data[196],
    4,
    4,
    0,
    1,
    1
  },
  /* ../../gcc/config/epiphany/epiphany.md:2662 */
  {
    "mulv2sf3_i",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_mulv2sf3_i },
    &operand_data[187],
    4,
    4,
    0,
    1,
    1
  },
  /* ../../gcc/config/epiphany/epiphany.md:2712 */
  {
    "*fmaddv2si_combine",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[200],
    5,
    5,
    0,
    1,
    1
  },
  /* ../../gcc/config/epiphany/epiphany.md:2712 */
  {
    "*fmaddv2sf_combine",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "#",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { 0 },
    &operand_data[205],
    5,
    5,
    0,
    1,
    1
  },
  /* ../../gcc/config/epiphany/epiphany.md:2808 */
  {
    "nop",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { .single =
#else
    {
#endif
    "nop",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    },
#else
    0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_nop },
    &operand_data[0],
    0,
    0,
    0,
    0,
    1
  },
  /* ../../gcc/config/epiphany/epiphany.md:112 */
  {
    "movsi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movsi },
    &operand_data[210],
    2,
    2,
    0,
    0,
    0
  },
  /* ../../gcc/config/epiphany/epiphany.md:112 */
  {
    "movsf",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movsf },
    &operand_data[212],
    2,
    2,
    0,
    0,
    0
  },
  /* ../../gcc/config/epiphany/epiphany.md:112 */
  {
    "movhi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movhi },
    &operand_data[214],
    2,
    2,
    0,
    0,
    0
  },
  /* ../../gcc/config/epiphany/epiphany.md:112 */
  {
    "movqi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movqi },
    &operand_data[216],
    2,
    2,
    0,
    0,
    0
  },
  /* ../../gcc/config/epiphany/epiphany.md:112 */
  {
    "movv2hi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movv2hi },
    &operand_data[218],
    2,
    2,
    0,
    0,
    0
  },
  /* ../../gcc/config/epiphany/epiphany.md:112 */
  {
    "movv4qi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movv4qi },
    &operand_data[220],
    2,
    2,
    0,
    0,
    0
  },
  /* ../../gcc/config/epiphany/epiphany.md:261 */
  {
    "reload_insi_ra",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_reload_insi_ra },
    &operand_data[222],
    2,
    2,
    0,
    1,
    0
  },
  /* ../../gcc/config/epiphany/epiphany.md:300 */
  {
    "movdi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movdi },
    &operand_data[224],
    2,
    2,
    0,
    0,
    0
  },
  /* ../../gcc/config/epiphany/epiphany.md:300 */
  {
    "movdf",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movdf },
    &operand_data[226],
    2,
    2,
    0,
    0,
    0
  },
  /* ../../gcc/config/epiphany/epiphany.md:300 */
  {
    "movv2si",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movv2si },
    &operand_data[228],
    2,
    2,
    0,
    0,
    0
  },
  /* ../../gcc/config/epiphany/epiphany.md:300 */
  {
    "movv2sf",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movv2sf },
    &operand_data[230],
    2,
    2,
    0,
    0,
    0
  },
  /* ../../gcc/config/epiphany/epiphany.md:300 */
  {
    "movv4hi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movv4hi },
    &operand_data[232],
    2,
    2,
    0,
    0,
    0
  },
  /* ../../gcc/config/epiphany/epiphany.md:300 */
  {
    "movv8qi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movv8qi },
    &operand_data[234],
    2,
    2,
    0,
    0,
    0
  },
  /* ../../gcc/config/epiphany/epiphany.md:417 */
  {
    "addsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_addsi3 },
    &operand_data[236],
    3,
    3,
    0,
    0,
    0
  },
  /* ../../gcc/config/epiphany/epiphany.md:562 */
  {
    "subsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_subsi3 },
    &operand_data[239],
    3,
    3,
    0,
    0,
    0
  },
  /* ../../gcc/config/epiphany/epiphany.md:597 */
  {
    "addsf3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_addsf3 },
    &operand_data[242],
    3,
    3,
    0,
    0,
    0
  },
  /* ../../gcc/config/epiphany/epiphany.md:615 */
  {
    "subsf3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_subsf3 },
    &operand_data[242],
    3,
    3,
    0,
    0,
    0
  },
  /* ../../gcc/config/epiphany/epiphany.md:632 */
  {
    "subsf3_f",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_subsf3_f },
    &operand_data[42],
    3,
    3,
    2,
    1,
    0
  },
  /* ../../gcc/config/epiphany/epiphany.md:653 */
  {
    "abssf2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_abssf2 },
    &operand_data[242],
    2,
    2,
    0,
    0,
    0
  },
  /* ../../gcc/config/epiphany/epiphany.md:669 */
  {
    "mulsf3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_mulsf3 },
    &operand_data[242],
    3,
    3,
    0,
    0,
    0
  },
  /* ../../gcc/config/epiphany/epiphany.md:687 */
  {
    "divsf3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_divsf3 },
    &operand_data[242],
    3,
    3,
    0,
    0,
    0
  },
  /* ../../gcc/config/epiphany/epiphany.md:716 */
  {
    "recipsf2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_recipsf2 },
    &operand_data[244],
    4,
    4,
    0,
    0,
    0
  },
  /* ../../gcc/config/epiphany/epiphany.md:791 */
  {
    "fmasf4",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_fmasf4 },
    &operand_data[248],
    4,
    4,
    0,
    0,
    0
  },
  /* ../../gcc/config/epiphany/epiphany.md:820 */
  {
    "maddsf",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_maddsf },
    &operand_data[53],
    4,
    4,
    0,
    1,
    0
  },
  /* ../../gcc/config/epiphany/epiphany.md:841 */
  {
    "fnmasf4",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_fnmasf4 },
    &operand_data[248],
    4,
    4,
    0,
    0,
    0
  },
  /* ../../gcc/config/epiphany/epiphany.md:874 */
  {
    "floatsisf2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_floatsisf2 },
    &operand_data[251],
    2,
    2,
    0,
    0,
    0
  },
  /* ../../gcc/config/epiphany/epiphany.md:889 */
  {
    "floatsisf2_cmp",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_floatsisf2_cmp },
    &operand_data[42],
    2,
    2,
    2,
    1,
    0
  },
  /* ../../gcc/config/epiphany/epiphany.md:910 */
  {
    "floatunssisf2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_floatunssisf2 },
    &operand_data[251],
    2,
    2,
    0,
    0,
    0
  },
  /* ../../gcc/config/epiphany/epiphany.md:930 */
  {
    "fix_truncsfsi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_fix_truncsfsi2 },
    &operand_data[252],
    2,
    2,
    0,
    0,
    0
  },
  /* ../../gcc/config/epiphany/epiphany.md:949 */
  {
    "fixuns_truncsfsi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_fixuns_truncsfsi2 },
    &operand_data[252],
    2,
    2,
    0,
    0,
    0
  },
  /* ../../gcc/config/epiphany/epiphany.md:998 */
  {
    "iadd",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_iadd },
    &operand_data[242],
    3,
    3,
    0,
    0,
    0
  },
  /* ../../gcc/config/epiphany/epiphany.md:1015 */
  {
    "isub",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_isub },
    &operand_data[242],
    3,
    3,
    0,
    0,
    0
  },
  /* ../../gcc/config/epiphany/epiphany.md:1083 */
  {
    "mulsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_mulsi3 },
    &operand_data[254],
    3,
    3,
    0,
    0,
    0
  },
  /* ../../gcc/config/epiphany/epiphany.md:1101 */
  {
    "maddsi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_maddsi },
    &operand_data[76],
    4,
    4,
    0,
    1,
    0
  },
  /* ../../gcc/config/epiphany/epiphany.md:1132 */
  {
    "divsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_divsi3 },
    &operand_data[257],
    3,
    3,
    1,
    0,
    0
  },
  /* ../../gcc/config/epiphany/epiphany.md:1207 */
  {
    "udivsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_udivsi3 },
    &operand_data[257],
    3,
    3,
    1,
    0,
    0
  },
  /* ../../gcc/config/epiphany/epiphany.md:1278 */
  {
    "modsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_modsi3 },
    &operand_data[257],
    3,
    3,
    1,
    0,
    0
  },
  /* ../../gcc/config/epiphany/epiphany.md:1351 */
  {
    "umodsi3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_umodsi3 },
    &operand_data[257],
    3,
    3,
    1,
    0,
    0
  },
  /* ../../gcc/config/epiphany/epiphany.md:1453 */
  {
    "movcc",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movcc },
    &operand_data[260],
    2,
    4,
    1,
    2,
    0
  },
  /* ../../gcc/config/epiphany/epiphany.md:1533 */
  {
    "one_cmplsi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_one_cmplsi2 },
    &operand_data[254],
    2,
    2,
    1,
    0,
    0
  },
  /* ../../gcc/config/epiphany/epiphany.md:1695 */
  {
    "abssi2",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_abssi2 },
    &operand_data[264],
    2,
    2,
    7,
    1,
    0
  },
  /* ../../gcc/config/epiphany/epiphany.md:1841 */
  {
    "cstoresi4",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_cstoresi4 },
    &operand_data[266],
    4,
    4,
    4,
    1,
    0
  },
  /* ../../gcc/config/epiphany/epiphany.md:1940 */
  {
    "movsicc",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movsicc },
    &operand_data[270],
    4,
    4,
    0,
    0,
    0
  },
  /* ../../gcc/config/epiphany/epiphany.md:1940 */
  {
    "movsfcc",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movsfcc },
    &operand_data[274],
    4,
    4,
    0,
    0,
    0
  },
  /* ../../gcc/config/epiphany/epiphany.md:1940 */
  {
    "movhicc",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movhicc },
    &operand_data[278],
    4,
    4,
    0,
    0,
    0
  },
  /* ../../gcc/config/epiphany/epiphany.md:1940 */
  {
    "movqicc",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movqicc },
    &operand_data[282],
    4,
    4,
    0,
    0,
    0
  },
  /* ../../gcc/config/epiphany/epiphany.md:1940 */
  {
    "movv2hicc",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movv2hicc },
    &operand_data[286],
    4,
    4,
    0,
    0,
    0
  },
  /* ../../gcc/config/epiphany/epiphany.md:1940 */
  {
    "movv4qicc",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movv4qicc },
    &operand_data[290],
    4,
    4,
    0,
    0,
    0
  },
  /* ../../gcc/config/epiphany/epiphany.md:2069 */
  {
    "cbranchsi4",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_cbranchsi4 },
    &operand_data[294],
    4,
    4,
    0,
    0,
    0
  },
  /* ../../gcc/config/epiphany/epiphany.md:2087 */
  {
    "cbranchsf4",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_cbranchsf4 },
    &operand_data[298],
    4,
    4,
    0,
    0,
    0
  },
  /* ../../gcc/config/epiphany/epiphany.md:2142 */
  {
    "tablejump",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_tablejump },
    &operand_data[302],
    2,
    2,
    0,
    0,
    0
  },
  /* ../../gcc/config/epiphany/epiphany.md:2173 */
  {
    "call",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_call },
    &operand_data[304],
    2,
    2,
    0,
    0,
    0
  },
  /* ../../gcc/config/epiphany/epiphany.md:2211 */
  {
    "sibcall",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sibcall },
    &operand_data[304],
    2,
    2,
    0,
    0,
    0
  },
  /* ../../gcc/config/epiphany/epiphany.md:2249 */
  {
    "call_value",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_call_value },
    &operand_data[306],
    3,
    3,
    0,
    1,
    0
  },
  /* ../../gcc/config/epiphany/epiphany.md:2292 */
  {
    "sibcall_value",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sibcall_value },
    &operand_data[306],
    3,
    3,
    0,
    1,
    0
  },
  /* ../../gcc/config/epiphany/epiphany.md:2335 */
  {
    "prologue",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_prologue },
    &operand_data[0],
    0,
    0,
    0,
    0,
    0
  },
  /* ../../gcc/config/epiphany/epiphany.md:2343 */
  {
    "epilogue",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_epilogue },
    &operand_data[0],
    0,
    0,
    0,
    0,
    0
  },
  /* ../../gcc/config/epiphany/epiphany.md:2351 */
  {
    "sibcall_epilogue",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_sibcall_epilogue },
    &operand_data[0],
    0,
    0,
    0,
    0,
    0
  },
  /* ../../gcc/config/epiphany/epiphany.md:2419 */
  {
    "vec_unpacks_lo_v4hi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_vec_unpacks_lo_v4hi },
    &operand_data[309],
    2,
    2,
    0,
    0,
    0
  },
  /* ../../gcc/config/epiphany/epiphany.md:2437 */
  {
    "vec_unpacks_hi_v4hi",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_vec_unpacks_hi_v4hi },
    &operand_data[309],
    2,
    2,
    0,
    0,
    0
  },
  /* ../../gcc/config/epiphany/epiphany.md:2501 */
  {
    "addv2sf3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_addv2sf3 },
    &operand_data[311],
    3,
    3,
    0,
    0,
    0
  },
  /* ../../gcc/config/epiphany/epiphany.md:2501 */
  {
    "subv2sf3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_subv2sf3 },
    &operand_data[311],
    3,
    3,
    0,
    0,
    0
  },
  /* ../../gcc/config/epiphany/epiphany.md:2555 */
  {
    "ashlv2si3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_ashlv2si3 },
    &operand_data[314],
    3,
    3,
    1,
    0,
    0
  },
  /* ../../gcc/config/epiphany/epiphany.md:2655 */
  {
    "mulv2si3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_mulv2si3 },
    &operand_data[317],
    3,
    3,
    0,
    0,
    0
  },
  /* ../../gcc/config/epiphany/epiphany.md:2655 */
  {
    "mulv2sf3",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_mulv2sf3 },
    &operand_data[311],
    3,
    3,
    0,
    0,
    0
  },
  /* ../../gcc/config/epiphany/epiphany.md:2777 */
  {
    "vec_setv2si",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_vec_setv2si },
    &operand_data[320],
    3,
    3,
    0,
    0,
    0
  },
  /* ../../gcc/config/epiphany/epiphany.md:2777 */
  {
    "vec_setv2sf",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_vec_setv2sf },
    &operand_data[323],
    3,
    3,
    0,
    0,
    0
  },
  /* ../../gcc/config/epiphany/epiphany.md:2790 */
  {
    "movmisalignv2si",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movmisalignv2si },
    &operand_data[326],
    2,
    2,
    0,
    0,
    0
  },
  /* ../../gcc/config/epiphany/epiphany.md:2790 */
  {
    "movmisalignv2sf",
#if HAVE_DESIGNATED_UNION_INITIALIZERS
    { 0 },
#else
    { 0, 0, 0 },
#endif
    { (insn_gen_fn::stored_funcptr) gen_movmisalignv2sf },
    &operand_data[328],
    2,
    2,
    0,
    0,
    0
  },
};


const char *
get_insn_name (int code)
{
  if (code == NOOP_MOVE_INSN_CODE)
    return "NOOP_MOVE";
  else
    return insn_data[code].name;
}
